#!/bin/bash
# Setting a version number and commit to VCS.
#
VERSION=$1
SCRIPT=`basename "$0"`
CURRENT=`dirname "$0"`
OUTFILE=${CURRENT}/../modules/cms/base/Version.class.php

if   [ -z "$VERSION" ]; then
  echo "Usage: $0 <version>" 1>&2;
  exit 1;
fi


function set_version {
  VERSION=$1
  DATE=$2
  DATE_STR=$3

  cat << EOF > $OUTFILE
<?php
// AUTO GENERATED.
// THIS FILE IS GENERATED BY $SCRIPT - DO NOT CHANGE.
namespace cms\base;
class Version {
    const VERSION = '${VERSION}';
    const DATE    = ${DATE};
}
EOF
}

DATE=`date +%s`

set_version $VERSION $DATE

#git commit -m "New version tag $VERSION" $OUTFILE
#git tag $VERSION

set_version 'dev-snapshot' 'null'

#git commit -m "Setting development status" $OUTFILE
